%global debug_package %{nil}
%global toolchain clang

Name:           qtile
Version:        0.31.0
Release:        1%{?dist}
Summary:        A pure-Python tiling window manager

License:        MIT AND GPL-3.0-or-later
URL:            https://%{name}.org
Source0:        %{pypi_source}
Source1:        99-%{name}.rules

BuildRequires:  clang
BuildRequires:  desktop-file-utils
BuildRequires:  pkgconfig(python3)
BuildRequires:  pkgconfig(x11)
BuildRequires:  python3dist(cairocffi)
BuildRequires:  python3dist(cffi)
BuildRequires:  python3dist(pip)
BuildRequires:  python3dist(setuptools)
BuildRequires:  python3dist(setuptools-scm)
BuildRequires:  python3dist(wheel)
BuildRequires:  python3dist(xcffib)
Recommends:     python3dist(dbus-next)
Recommends:     python3dist(psutil)
Recommends:     python3dist(pulsectl)
Recommends:     python3dist(pulsectl-asyncio)
Recommends:     python3dist(python-dateutil)
Recommends:     python3dist(python-mpd2)
Recommends:     python3dist(pyxdg)
Recommends:     python3dist(xmltodict)
Requires:       python3-libqtile = %{version}-%{release}

%global _description %{expand:
A full-featured, pure-Python tiling window manager.

Features:
* Simple, small and extensible. It's easy to write your own layouts, widgets and commands.
* Configured in Python.
* Runs as an X11 WM or a Wayland compositor.
* Command shell that allows all aspects of Qtile to be managed and inspected.
* Complete remote scriptability - write scripts to set up workspaces, manipulate windows, update status bar widgets and more.
* Qtile's remote scriptability makes it one of the most thoroughly unit-tested window managers around.}

%description %_description

%package -n python3-libqtile
Summary:        Qtile's python library

%description -n python3-libqtile
%{summary}.

%package wayland
Summary:        Qtile wayland session
BuildRequires:  pkgconfig(wlroots)
BuildRequires:  python3dist(pywayland)
BuildRequires:  python3dist(pywlroots)
BuildRequires:  python3dist(xkbcommon)
BuildRequires:  xorg-x11-server-Xwayland
Requires:       python3-libqtile+wayland = %{version}-%{release}
Requires:       qtile = %{version}-%{release}

%description wayland
%{summary}.


%pyproject_extras_subpkg -n python3-libqtile wayland

%prep
%autosetup -p1 -n %{name}-%{version}


%generate_buildrequires
%pyproject_buildrequires -x wayland


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files -l libqtile

mkdir -p %{buildroot}%{_datadir}/xsessions/
desktop-file-install \
  --dir %{buildroot}%{_datadir}/xsessions/ \
  resources/%{name}.desktop

mkdir -p %{buildroot}%{_datadir}/wayland-sessions/
desktop-file-install \
  --dir %{buildroot}%{_datadir}/wayland-sessions/ \
  resources/%{name}-wayland.desktop

mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d/
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/udev/rules.d/


%files
%doc CHANGELOG README.rst
%{_bindir}/%{name}
%{_datadir}/xsessions/%{name}.desktop
%{_sysconfdir}/udev/rules.d/99-%{name}.rules

%files -n python3-libqtile -f %{pyproject_files}


%files wayland
%{_datadir}/wayland-sessions/%{name}-wayland.desktop


%changelog
* Fri Apr 04 2025 David Andres Ramirez Salomon <david35mm@disroot.org> - 0.31.0-1
- Updated to v0.31.0 and followed new Fedora python packaging guidelines
